﻿Option Explicit On

Public Class frmHalbr
    Shared Wert1 As Single
    Shared Eingaben As New Collection()
    Shared Vektorvz As New Collection()
    Shared Vektorvx As New Collection()
    Shared Vektorsigz As New Collection()
    Shared Vektorsigx As New Collection()
    Shared Vektorsigy As New Collection()
    Shared lR As Integer : Shared dZ As Integer
    Shared T1 As Integer
    Shared T2 As Integer : Shared T3 As Integer : Shared T4 As Integer : Shared T5 As Integer
    Shared T6 As Integer : Shared T7 As Integer : Shared T8 As Integer
    Const Pfad = "C:\Benutzer\Bernd\Programme\WIT_VB_2010\Zerl3\"
    Shared blnSicher As Boolean
    Public IP As Single

    Private Sub frmHalbr_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Ausgabe As String

        With Me
            .WindowState = 2
            .Text = "Programm " + strPgmName + ", Version " + strVersion

            Ausgabe = "Verformungen und Spannungen im elastischen Halbraum bei rechteckförmiger" + vbCrLf
            Ausgabe = Ausgabe + "Oberflächenlast nach Grundbau-Taschenbuch 1, 5. Auflage"
            .Label11.Text = Ausgabe
            .Label11.Font = New Font("arial", 12, FontStyle.Bold)

            Call Vorbelegung()
            IP = 0
            .GroupBox1.Text = "Eingaben"
            .GroupBox2.Text = "Berechnung"
            .GroupBox1.Font = New Font("arial", 11, FontStyle.Regular, ForeColor = Color.Black)
            .GroupBox2.Font = New Font("arial", 11, FontStyle.Regular, ForeColor = Color.Black)

            .Label1.Text = "Flächenlast" + vbCrLf + "vertikal qv [kN/m²]"
            .Label2.Text = "horizontal qh"
            .Label3.Text = "Breite in x-Ri. Bx [m]"
            .Label4.Text = "... in y-Ri. By [m]"
            .TextBox1.Text = ""
            .TextBox2.Text = ""
            .TextBox3.Text = ""

            .Label5.Text = "Boden" + vbCrLf + "Steifemodul Es [N/mm²]"
            .Label6.Text = "Querdehnzahl mue"
            .TextBox4.Text = ""
            .TextBox5.Text = ""

            .Label7.Text = "Tiefe z [m]"
            .Label8.Text = "Abstand der Last in y-Richtung [m]"
            .Label9.Text = "Bereichslänge lx [m]"
            .Label10.Text = "Bereichsbreite ly [m]"
            .Label12.Text = "in x-Richtung"
            .Label13.Text = "Teilung in x-Richtung"
            .Label14.Text = "Teilung in y-Richtung"
            .Label15.Text = "Tabelle vz, sigma z"
            .TextBox6.Text = ""
            .TextBox7.Text = ""
            .TextBox8.Text = ""
            .TextBox11.Text = ""

            '.Command3.text = "Berechnen"
            '.Command4.text = "Speichern"

            Call FelderBelegen()

            .CheckBox1.Text = "Symmetrie"
            If blnSymmetrie Then
                .CheckBox1.Checked = True
            Else
                .CheckBox1.Checked = False
            End If

            blnBerechnung = False
        End With

    End Sub

    Private Sub FelderBelegen()
        With Me
            .TextBox1.Text = Format(qz, "##0.00")
            .TextBox2.Text = Format(qh, "##0.00")
            .TextBox3.Text = Format(Bx, "##0.00")
            .TextBox4.Text = Format(By, "##0.00")
            .TextBox5.Text = Format(Es, "##0.00")
            .TextBox6.Text = Format(mue, "##0.00")
            .TextBox7.Text = Format(z, "##0.00")
            .TextBox8.Text = Format(y0, "##0.00")
            .TextBox9.Text = Format(lx, "##0.00")
            .TextBox10.Text = Format(ly, "##0.00")
            .TextBox11.Text = Format(x0, "##0.00")
            .TextBox12.Text = Format(nTx, "##0")
            .TextBox13.Text = Format(nTy, "##0")
        End With
    End Sub

    Private Sub VektorDef()
        Dim Zeile As String

        Eingaben.Clear()
        Eingaben.Add("Verformungsmulde und Spannungen ")
        Eingaben.Add("nach Grundbau-Taschenbuch Teil 1 - 5. Aufl. 1996")
        Eingaben.Add("Auflast GOK qz = " + Str(qz) + " kN/m²")
        Eingaben.Add("Horizontallast GOK qh = " + Str(qh) + " kN/m²")
        Eingaben.Add("Lastlänge Bx = " + Str(Bx) + " m")
        Eingaben.Add("Lastbreite By = " + Str(By) + " m")
        Eingaben.Add("Steifemodul Es = " + Str(Es) + " N/mm²")
        Eingaben.Add("Querkontraktion mue = " + Str(mue))
        Eingaben.Add("Tiefe z = " + Str(z) + " m")
        Eingaben.Add("Abstand y0 = " + Str(y0) + " m")
        Eingaben.Add("Abstand x0 = " + Str(x0) + " m")
        Eingaben.Add("Auswertungslänge lx = " + Str(lx) + " m")
        Eingaben.Add("Auswertungslänge ly = " + Str(ly) + " m")
        'Eingaben.Add("E-Modul E = " + Format(EMod, "##0.00") + " N/mm²")

        Vektorvz.Clear()
        Vektorvz.Add("Verformungen vz")
        For i = 0 To nTx
            Zeile = ""
            For j = 0 To nTy
                Zeile = Zeile + vz_A(i, j).ToString(" 0.000  ")
            Next j
            Vektorvz.Add(Zeile)
        Next i

        Vektorvx.Clear()
        Vektorvx.Add("Verformungen vx")
        For i = 0 To nTx
            Zeile = ""
            For j = 0 To nTy
                Zeile = Zeile + vx_A(i, j).ToString(" 0.000  ")
            Next j
            Vektorvx.Add(Zeile)
        Next i

        Vektorsigz.Clear()
        Vektorsigz.Add("Spannungen sigz")
        For i = 0 To nTx
            Zeile = ""
            For j = 0 To nTy
                Zeile = Zeile + sig_A(i, j).ToString(" 0.000  ")
            Next j
            Vektorsigz.Add(Zeile)
        Next i

        Vektorsigx.Clear()
        Vektorsigx.Add("Spannungen sigx")
        For i = 0 To nTx
            Zeile = ""
            For j = 0 To nTy
                Zeile = Zeile + sigx_A(i, j).ToString(" 0.000  ")
            Next j
            Vektorsigx.Add(Zeile)
        Next i

        Vektorsigy.Clear()
        Vektorsigy.Add("Spannungen sigy")
        For i = 0 To nTx
            Zeile = ""
            For j = 0 To nTy
                Zeile = Zeile + sigy_A(i, j).ToString(" 0.000  ")
            Next j
            Vektorsigy.Add(Zeile)
        Next i
    End Sub

    Private Sub textbox1_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        'Eingabe Auflast
        Call EingPr(TextBox1.Text, "vertikale Flächenlast qz ", 0, 10000)
        qz = Wert1
    End Sub

    Private Sub textbox2_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        'Eingabe H-Last
        Call EingPr(TextBox2.Text, "horizontale Flächenlast qh ", -10000, 10000)
        If Math.Abs(qh) > 0 Then
            CheckBox1.Checked = True
            blnSymmetrie = False
            Exit Sub
        End If
        qh = Wert1
    End Sub

    Private Sub textbox3_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox3.Leave
        'Eingabe Länge Flächenlast
        Call EingPr(TextBox3.Text, "Seitenlänge bx ", 0, 10000)
        Bx = Wert1
    End Sub

    Private Sub textbox4_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox4.Leave
        'Eingabe Breite Flächenlast
        Call EingPr(TextBox4.Text, "Seitenlänge by ", 0, 10000)
        By = Wert1
    End Sub

    Private Sub textbox5_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox5.Leave
        'Eingabe Steifemodul
        Call EingPr(TextBox5.Text, "Steifemodul Es ", 0.00001, 10000)
        Es = Wert1
    End Sub

    Private Sub textbox6_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox6.Leave
        'Eingabe mue
        Call EingPr(TextBox6.Text, "Querkontraktionszahl ", 0, 0.5)
        mue = Wert1
    End Sub

    Private Sub textbox7_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox7.Leave
        'Eingabe Tiefe z
        Call EingPr(TextBox7.Text, "Überdeckungshöhe z ", 0.001, 10000)
        z = Wert1
    End Sub

    Private Sub textbox8_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox8.Leave
        'Abstand y0
        Call EingPr(TextBox8.Text, "Abstand y0 ", -10000, 10000)
        y0 = Wert1
    End Sub

    Private Sub textbox9_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox9.Leave
        'Bereich lx
        Call EingPr(TextBox9.Text, "Berechnungsbereich lx ", 0, 10000)
        lx = Wert1
    End Sub

    Private Sub textbox10_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox10.Leave
        'Bereich ly
        Call EingPr(TextBox10.Text, "Berechnungsbereich ly ", 0, 10000)
        ly = Wert1
    End Sub

    Private Sub textbox11_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox11.Leave
        'Abstand x0
        Call EingPr(TextBox11.Text, "Abstand x0 ", -10000, 10000)
        x0 = Wert1
    End Sub

    Private Sub textbox12_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox12.Leave
        'Teilung in x-Richtung
        Call EingPr(TextBox12.Text, "Teilung in x-Richtung ", 1, 100)
        nTx = Wert1
    End Sub

    Private Sub textbox13_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox13.Leave
        'Teilung in y-Richtung
        Call EingPr(TextBox13.Text, "Teilung in y-Richtung ", 1, 100)
        nTy = Wert1
    End Sub

    Private Sub showlistView(ByVal X(,) As Single)
        Dim i As Integer, j As Integer
        With ListView1
            .GridLines = True
            .Clear()
            .Columns.Add("", 30, HorizontalAlignment.Right)                '1. Spalte, 30 Pixel
            For j = 0 To X.GetLength(1) - 1
                .Columns.Add(j.ToString, 50, HorizontalAlignment.Center)   'Kopfzeile
            Next j
            For i = 0 To X.GetLength(0) - 1
                Dim Item As New ListViewItem(i.ToString)
                For j = 0 To X.GetLength(1) - 1
                    Item.SubItems.Add(X(i, j).ToString("0.00"))
                Next j
                .Items.Add(Item)
            Next i
        End With
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Berechnung Verformung und Anzeige in Grid
        Call Dimensionierung()

        If Math.Abs(qz) >= 0 Then Call BodenSpgVerf_qz()
        If Math.Abs(qh) > 0 Then Call BodenSpgVerf_qx()
        blnBerechnung = True

        If IP = 0 Then IP = 1

        Select Case IP
            Case 1
                Call showlistView(vz_A)
            Case 2
                Call showlistView(vx_A)
            Case 3
                Call showlistView(sig_A)
            Case 4
                Call showlistView(sigx_A)
            Case 5
                Call showlistView(sigy_A)
        End Select
        Me.Label15.Text = IP.ToString + ". " + strLinie(IP) + ", max = " + strZahl(IP)
        Me.Label15.Font = New Font("arial", 12, FontStyle.Bold)

    End Sub

    Sub LoadText(ByVal Dateiname As String)
        Dim i As Integer
        Dim teil() As String
        Try
            ListView1.Clear()
            Dim Text As String
            Eingaben.Clear()
            Using Datei As IO.StreamReader = New IO.StreamReader(Dateiname)
                For i = 1 To 13
                    Text = Datei.ReadLine()
                    Eingaben.Add(Text)
                Next i
                Datei.Close()
            End Using

            For i = 3 To 13
                teil = Eingaben.Item(i).split(" ")
                Select Case i
                    Case 3 : qz = Val(teil(5))
                    Case 4 : qh = Val(teil(5))
                    Case 5 : Bx = Val(teil(4))
                    Case 6 : By = Val(teil(4))
                    Case 7 : Es = Val(teil(4))
                    Case 8 : mue = Val(teil(4))
                    Case 9 : z = Val(teil(4))
                    Case 10 : y0 = Val(teil(4))
                    Case 11 : x0 = Val(teil(4))
                    Case 12 : lx = Val(teil(4))
                    Case 13 : ly = Val(teil(4))
                        'Case 14 : EMod = Val(teil(4))
                End Select
            Next i
        Catch
            MsgBox("Fehler in der Sub LoadText: " + Err.Description)
        End Try
    End Sub

    Sub SaveText(ByVal Dateiname As String)
        Try
            Dim i As Integer
            Call VektorDef()
            Using Datei As IO.StreamWriter = New IO.StreamWriter(Dateiname)
                For i = 1 To Eingaben.Count
                    Datei.WriteLine(Eingaben.Item(i))
                Next
                For i = 1 To Vektorvz.Count
                    Datei.WriteLine(Vektorvz.Item(i))
                Next
                For i = 1 To Vektorvx.Count
                    Datei.WriteLine(Vektorvx.Item(i))
                Next
                For i = 1 To Vektorsigz.Count
                    Datei.WriteLine(Vektorsigz.Item(i))
                Next
                For i = 1 To Vektorsigx.Count
                    Datei.WriteLine(Vektorsigx.Item(i))
                Next
                For i = 1 To Vektorsigy.Count
                    Datei.WriteLine(Vektorsigy.Item(i))
                Next
                Datei.Close()
            End Using
            blnSicher = True
        Catch
            MsgBox("Fehler in der Sub SaveText: " + Err.Description)
            blnSicher = False
        End Try
    End Sub

    Private Sub ÖffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ÖffnenToolStripMenuItem.Click
        OpenFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        OpenFileDialog1.ShowDialog()
        LoadText(OpenFileDialog1.FileName)
        Call FelderBelegen()
    End Sub

    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click
        If blnBerechnung = False Then
            MessageBox.Show("zuerst Berechnen wählen!")
            Exit Sub
        End If
        SaveFileDialog1.Filter = "txt files (*.txt)|*.txt"
        SaveFileDialog1.ShowDialog()
        If SaveFileDialog1.FileName <> "" Then SaveText(SaveFileDialog1.FileName)
    End Sub

    Private Sub DruckenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DruckenToolStripMenuItem.Click
        With PrintPreviewDialog1
            .Document = PrintDocument1
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                PrintDocument1.Print()
            End If
        End With
    End Sub

    Private Sub EndeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EndeToolStripMenuItem.Click
        Close()
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim dx As Single, dy As Single
        Dim strZ(6) As String
        Dim g As Graphics = e.Graphics
        Dim Schrift1 As Font = New Font("arial", 14, FontStyle.Bold)
        Dim Schrift2 As Font = New Font("courier new", 12, FontStyle.Regular)
        Dim Schrift3 As Font = New Font("courier new", 10, FontStyle.Regular)
        Dim j As Single, j1 As Single, sl As Single
        lR = 50 : dZ = 20
        Call Tabulatoren(1)
        'Call ZeilenDef()
        g.DrawString("Programm " + strPgmName + ", Version " + strVersion, Schrift1, Brushes.Black, lR, 40)
        g.DrawString("Projekt: " + strProjekt + "   Einheiten: " + strEHF + "; " + strEHL, Schrift2, Brushes.Black, lR, 70)
        g.DrawString("*** Eingaben ***", Schrift1, Brushes.Black, lR, 100)
        j = 1
        sl = qz.ToString("0.00").Length * 12
        g.DrawString("Flächenlast, vertikal", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("qv", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(qz.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHS, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = qh.ToString("0.00").Length * 12
        g.DrawString("Flächenlast, horizontal", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("qh", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(qh.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHS, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = Bx.ToString("0.00").Length * 12
        g.DrawString("Lastbreite, x-Richtung", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("Bx", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(Bx.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = By.ToString("0.00").Length * 12
        g.DrawString("Lastbreite, y-Richtung", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("By", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(By.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = Es.ToString("0.00").Length * 12
        g.DrawString("Boden, Steifemodul", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("Es", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(Es.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString("N/mm²", Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = mue.ToString("0.00").Length * 12
        g.DrawString("        Querdehnzahl", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("mue", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(mue.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        j = j + 1.5
        sl = z.ToString("0.00").Length * 12
        g.DrawString("Tiefe", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("z", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(z.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = x0.ToString("0.00").Length * 12
        g.DrawString("Abstand der Last in x-Richtung", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("x0", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(x0.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = y0.ToString("0.00").Length * 12
        g.DrawString("Abstand der Last in y-Richtung", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("y0", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(y0.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = lx.ToString("0.00").Length * 12
        g.DrawString("Bereichslänge ", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("lx", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(lx.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = ly.ToString("0.00").Length * 12
        g.DrawString("Bereichslänge ", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("ly", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(ly.ToString("0.00"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        g.DrawString(strEHL, Schrift2, Brushes.Black, T5, 110 + j * dZ)
        j = j + 1
        sl = nTx.ToString("0").Length * 12
        g.DrawString("Teilung in x-Richtung ", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("nTx", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(nTx.ToString("0"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)
        j = j + 1
        sl = nTy.ToString("0").Length * 12
        g.DrawString("Teilung in y-Richtung ", Schrift2, Brushes.Black, lR, 110 + j * dZ)
        g.DrawString("nTy", Schrift2, Brushes.Black, T2, 110 + j * dZ)
        g.DrawString("=", Schrift2, Brushes.Black, T3, 110 + j * dZ)
        g.DrawString(nTy.ToString("0"), Schrift2, Brushes.Black, T4 - sl, 110 + j * dZ)

        'Ergebnisse
        j = j + 2
        g.DrawString("*** Ergebnisse ***", Schrift1, Brushes.Black, lR, 110 + j * dZ)
        Call Tabulatoren(2)
        j = j + 1.5
        Dim tabs() As Single = {95.0}         '95 = Abstand der Tabstops in einem Array, hier konstant
        Dim f As New StringFormat
        f.SetTabStops(0, tabs)
        g.DrawString("x" & vbTab & "y" & vbTab & "vz" & vbTab & "vx" & vbTab & "sigz" & vbTab & _
                     "sigx" & vbTab & "sigy", Schrift3, Brushes.Black, T1 - sl, 110 + j * dZ, f)
        j = j + 1
        g.DrawString("m" & vbTab & "m" & vbTab & "mm" & vbTab & "mm" & vbTab & strEHS & vbTab & _
                     strEHS & vbTab & strEHS, Schrift3, Brushes.Black, T1 - sl, 110 + j * dZ, f)
        dx = lx / nTx
        dy = ly / nTy
        For ix = 0 To nTx
            x = ix * dx
            j = j + 1
            sl = x.ToString("0.00").Length * 10
            g.DrawString(x.ToString("0.00"), Schrift3, Brushes.Black, T1 - sl, 110 + j * dZ)
            For iy = 0 To nTy
                y = iy * dy
                j = j + 1
                j1 = 110 + j * dZ
                sl = y.ToString("0.00").Length * 10
                g.DrawString(y.ToString("0.00"), Schrift3, Brushes.Black, T2 - sl, j1)
                sl = vz_A(ix, iy).ToString("0.00").Length * 10
                g.DrawString(vz_A(ix, iy).ToString("0.00"), Schrift3, Brushes.Black, T3 - sl, j1)
                sl = vx_A(ix, iy).ToString("0.00").Length * 10
                g.DrawString(vx_A(ix, iy).ToString("0.00"), Schrift3, Brushes.Black, T4 - sl, j1)
                sl = sig_A(ix, iy).ToString("0.000").Length * 10
                g.DrawString(sig_A(ix, iy).ToString("0.000"), Schrift3, Brushes.Black, T5 - sl, j1)
                sl = sigx_A(ix, iy).ToString("0.000").Length * 10
                g.DrawString(sigx_A(ix, iy).ToString("0.000"), Schrift3, Brushes.Black, T6 - sl, j1)
                sl = sigy_A(ix, iy).ToString("0.000").Length * 10
                g.DrawString(sigy_A(ix, iy).ToString("0.000"), Schrift3, Brushes.Black, T7 - sl, j1)
            Next iy
        Next ix
    End Sub

    Private Sub Tabulatoren(ByVal Zahl As Integer)
        Select Case Zahl
            Case 1
                T2 = 380 : T3 = 430 : T4 = 545 : T5 = 550
            Case 2
                T1 = 100 : T2 = 200 : T3 = 300 : T4 = 400 : T5 = 500 : T6 = 600 : T7 = 700
        End Select
    End Sub

    Public Sub EingPr(ByVal Eing1 As String, ByVal Atext1 As String, _
                      ByVal minW As Single, ByVal maxW As Single)
        'Austausch "," gegen "."
        Dim Stelle As Integer

        Stelle = InStr(Eing1, ",")
        If Stelle > 0 Then
            Mid(Eing1, Stelle, 1) = "."
        End If
        Wert1 = Val(Eing1)
        If InStr(Eing1, ".") = 2 And Len(Eing1) = 2 And Wert1 = 0 Then Exit Sub

        'Wertprüfung
        If Wert1 < minW Then
            MsgBox("Der untere Grenzwert " + Atext1 + "=" + Str(minW) + _
                    " wird unterschritten, Eingabe überprüfen!")
            Wert1 = minW
        End If
        If Wert1 > maxW Then
            MsgBox("Der obere Grenzwert " + Atext1 + "=" + Str(maxW) + _
                    " wird überschritten, Eingabe überprüfen!")
            Wert1 = maxW
        End If
    End Sub   'EingPr

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Ausgabe in neue Plotform
        If blnBerechnung Then
            frmHalbrPlot.Show()
        End If
    End Sub

End Class
