﻿Option Explicit On

Public Class frmHalbrPlot

    Shared Wert1 As Single
    Public IP As Integer, PLOT As Integer
    Public IP1 As Integer
    Public BX0 As Integer, BY0 As Integer
    Public XR As Integer
    Public XA As Single, XE As Single, YA As Single, YE As Single

    Public MA As Single, MS As Single
    Public zentx As Integer, zenty As Integer
    Public ZE As Integer, SP As Integer
    Public xP(,) As Single, yP(,) As Single
    Public AZ(,) As Single
    Public xPTa As Single, xPTe As Single
    Public yPTa As Single, yPTe As Single
    Public xPTa1 As Single, xPTe1 As Single
    Public xPTa2 As Single, xPTe2 As Single

    Public dx As Single, dy As Single
    Public ix As Integer

    Public p As System.Drawing.Graphics

    Shared Stift1 As New Pen(Color.LightGray, 1)
    Shared Stift2 As New Pen(Color.Gray, 2)

    Private Sub frmPlat1Plot_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aus As String
        With Me
            .WindowState = 0
            .Text = "Grafik - Darstellung"
            .Label1.Text = "Belastungsfunktion und Zustandslinien"
            .Label1.Font = New Font("arial", 12, FontStyle.Bold)
            .Label2.Text = ""
            .Label2.Font = New Font("arial", 12, FontStyle.Bold)
            .Label3.Text = ""

            .GroupBox1.Text = "Verzerrung "
            .Label4.Text = "x-Richtung"
            .Label5.Text = "y-Richtung"
            .TextBox1.Text = Str(verx)
            .TextBox2.Text = Str(very)
            aus = "Perspektive: x=1, y=0,6" + vbCrLf
            aus = aus + "Draufsicht: x=0, y=1" + vbCrLf
            aus = aus + "Seitenansicht: x=1, y=0"
            .Label6.Text = aus
            .Label7.Text = ""

            .GroupBox2.Text = "Darstellung "

            .CheckBox1.Text = "Symmetrie"
            .CheckBox2.Text = "Grundlinien"
            .CheckBox3.Text = "Lastfläche"
            ix = 0
        End With
    End Sub

    Private Sub frmPlat1Plot_paint(ByVal sender As System.Object, ByVal e As PaintEventArgs) Handles MyBase.Paint
        'Paint-Ereignis zum Neuzeichnen der Grafik
        If IP1 = 0 Then IP1 = 1
        If ix = 0 Then
            Call Start_Plotten(1, IP1)
            Call Plotten_1(1, IP1)
        End If
        ix = ix + 1
    End Sub

    Private Sub Start_Plotten(ByVal PLOT As Integer, ByVal IP As Integer)
        Dim ix As Integer, iy As Integer
        Dim XX As Integer, YY As Integer
        Dim EX As Single, EY As Single

        Call DimensionierungPlot()
        If IP = 0 Then IP = 1

        If PLOT = 1 Then
            p = Me.CreateGraphics            'Grafik in frmHalbrPlot
        Else
            p = frmHalbr.CreateGraphics      'Grafik in frmHalbr
        End If

        BX0 = Me.Width * 0.8
        BY0 = Me.Height * 0.8

        XR = BX0 / 10
        XX = BX0 - 2 * XR : YY = BY0 - 2 * XR

        'Netzkoordinaten transformieren
        For ix = 0 To nTx
            For iy = 0 To nTy
                xP(ix, iy) = -lx + ix * lx / 20 + verx * (iy) * ly / 20
                yP(ix, iy) = (-ly + iy * ly / 20) * very
            Next iy
        Next ix

        'Maßstab berechnen
        XA = 100000.0! : XE = -XA
        YA = 100000.0! : YE = -YA
        For ix = 0 To nTx
            For iy = 0 To nTy
                If XA > xP(ix, iy) Then XA = xP(ix, iy)
                If XE < xP(ix, iy) Then XE = xP(ix, iy)
                If YA > yP(ix, iy) Then YA = yP(ix, iy)
                If YE < yP(ix, iy) Then YE = yP(ix, iy)
            Next iy
        Next ix
        EX = Math.Abs(XE - XA) : If EX = 0 Then EX = 1
        EY = Math.Abs(YE - YA) : If EY = 0 Then EY = 1
        MA = XX / EX : If MA > YY / EY Then MA = YY / EY

        'Bildzentrierung
        If blnSymmetrie Then
            zentx = (XX - (EX + Bx / 2) * MA) / 2
        Else
            zentx = (XX - EX * MA) / 2
        End If
        zenty = (YY - EY * MA) / 2

    End Sub   'Start_Plotten

    Public Sub Plotten_1(ByVal PLOT As Integer, ByVal IP As Integer)
        'Bildschirmgrafik

        Select Case IP
            Case 1 : Call Plotten_Ord(IP, vz_A)
            Case 2 : Call Plotten_Ord(IP, vx_A)
            Case 3 : Call Plotten_Ord(IP, sig_A)
            Case 4 : Call Plotten_Ord(IP, sigx_A)
            Case 5 : Call Plotten_Ord(IP, sigy_A)
        End Select

        Me.Label2.Text = IP.ToString + ". " + strLinie(IP) + ", max = " + strZahl(IP)
        Me.Label2.Font = New Font("arial", 12, FontStyle.Bold)

    End Sub   'Plotten_1

    Public Sub Plotten_Ord(ByVal IP As Integer, ByVal AZ(,) As Single)
        'Ordinaten zeichnen
        Dim ix As Integer, iy As Integer
        Dim xPA As Integer, xPE As Integer
        Dim yPA As Integer, yPE As Integer
        Dim Farbe As New Color
        Dim g As Graphics = Me.CreateGraphics

        'Linien in x-Richtung
        If IP = 1 Or IP = 2 Then Farbe = Color.LightGreen
        Call Plotten_Sys()

        Call Maßstab(IP, AZ)

        'Linien in x-Richtung
        For iy = 0 To nTy
            For ix = 0 To nTx - 1
                xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                yPA = CInt(XR + MA * (yP(ix, iy) - YA) + AZ(ix, iy) * MS + zenty)
                xPE = CInt(XR + MA * (xP(ix + 1, iy) - XA) + zentx)
                yPE = CInt(XR + MA * (yP(ix + 1, iy) - YA) + AZ(ix + 1, iy) * MS + zenty)
                If IP = 3 Or IP = 4 Or IP = 5 Then
                    If AZ(ix + 1, iy) < 0 Then Farbe = Color.Red Else Farbe = Color.Blue
                End If
                g.DrawLine(New Pen(Farbe), xPA, BY0 - yPA, xPE, BY0 - yPE)
            Next ix
        Next iy
        'Linien in y-Richtung
        For iy = 0 To nTy - 1
            For ix = 0 To nTx
                xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                yPA = CInt(XR + MA * (yP(ix, iy) - YA) + AZ(ix, iy) * MS + zenty)
                xPE = CInt(XR + MA * (xP(ix, iy + 1) - XA) + zentx)
                yPE = CInt(XR + MA * (yP(ix, iy + 1) - YA) + AZ(ix, iy + 1) * MS + zenty)
                If IP = 3 Or IP = 4 Or IP = 5 Then
                    If AZ(ix, iy + 1) < 0 Then Farbe = Color.Red Else Farbe = Color.Blue
                End If
                g.DrawLine(New Pen(Farbe), xPA, BY0 - yPA, xPE, BY0 - yPE)
            Next ix
        Next iy

        'Ordinaten = vertikale Linien
        If blnGrundlinien Then
            For iy = 0 To nTy
                For ix = 0 To nTx
                    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                    yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
                    xPE = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                    yPE = CInt(XR + MA * (yP(ix, iy) - YA) + AZ(ix, iy) * MS + zenty)
                    Farbe = Color.Gray
                    g.DrawLine(New Pen(Farbe), xPA, BY0 - yPA, xPE, BY0 - yPE)
                Next ix
            Next iy
        End If

    End Sub   'Plotten_Ord

    Public Sub Plotten_Sys()
        'Raster zeichnen
        Dim ix As Integer, iy As Integer
        Dim xPA As Integer, xPE As Integer
        Dim yPA As Integer, yPE As Integer
        Dim g As Graphics = Me.CreateGraphics

        For iy = 0 To nTy
            For ix = 0 To nTx - 1
                xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
                xPE = CInt(XR + MA * (xP(ix + 1, iy) - XA) + zentx)
                yPE = CInt(XR + MA * (yP(ix + 1, iy) - YA) + zenty)
                If blnGrundlinien Then
                    g.DrawLine(Stift1, xPA, BY0 - yPA, xPE, BY0 - yPE)
                Else
                    If iy = 0 Or iy = nTy Then
                        g.DrawLine(Stift1, xPA, BY0 - yPA, xPE, BY0 - yPE)
                    End If
                End If
            Next ix
        Next iy
        For iy = 0 To nTy - 1
            For ix = 0 To nTx
                xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
                yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
                xPE = CInt(XR + MA * (xP(ix, iy + 1) - XA) + zentx)
                yPE = CInt(XR + MA * (yP(ix, iy + 1) - YA) + zenty)
                If blnGrundlinien Then
                    g.DrawLine(Stift1, xPA, BY0 - yPA, xPE, BY0 - yPE)
                Else
                    If ix = 0 Or ix = nTx Then
                        g.DrawLine(Stift1, xPA, BY0 - yPA, xPE, BY0 - yPE)
                    End If
                End If
            Next ix
        Next iy

        If blnLastfläche Then
            Call Plotten_Last()
        End If

    End Sub   'Plotten_Sys

    Public Sub Plotten_Last()
        'Lastrechteck zeichnen
        Dim xPA As Integer, xPE As Integer
        Dim yPA As Integer, yPE As Integer
        Dim xPA1 As Integer, xPE1 As Integer
        Dim xPTa1 As Single, xPTe1 As Single
        Dim xPTa2 As Single, xPTe2 As Single
        Dim yPTa1 As Single, yPTe1 As Single
        Dim g As Graphics = Me.CreateGraphics

        'Lastrechteck transformieren
        xPTa1 = -Bx / 2 + verx * (lx - By / 2) : xPTe1 = Bx / 2 + verx * (lx - By / 2)
        xPTa2 = -Bx / 2 + verx * (lx + By / 2) : xPTe2 = Bx / 2 + verx * (lx + By / 2)
        yPTa1 = -By / 2 * very : yPTe1 = By / 2 * very
        xPA = CInt(XR + MA * (xPTa1 - XA) + zentx)
        xPA1 = CInt(XR + MA * (xPTa2 - XA) + zentx)
        xPE = CInt(XR + MA * (xPTe1 - XA) + zentx)
        xPE1 = CInt(XR + MA * (xPTe2 - XA) + zentx)
        yPA = CInt(XR + MA * (yPTa1 - YA) + zenty)
        yPE = CInt(XR + MA * (yPTe1 - YA) + zenty)

        g.DrawLine(Stift2, xPA, BY0 - yPA, xPE, BY0 - yPA)
        g.DrawLine(Stift2, xPA1, BY0 - yPE, xPE1, BY0 - yPE)
        g.DrawLine(Stift2, xPA, BY0 - yPA, xPA1, BY0 - yPE)
        g.DrawLine(Stift2, xPE, BY0 - yPA, xPE1, BY0 - yPE)
    End Sub   'Plotten_Last

    Public Sub Maßstab(ByVal IP As Integer, ByVal AZ(,) As Single)
        'Maßstab berechnen
        Dim MZ As Single
        Dim ix As Integer, iy As Integer
        MZ = -1000000
        For ix = 1 To nTx : For iy = 1 To nTy
                If Math.Abs(AZ(ix, iy)) > MZ Then MZ = Math.Abs(AZ(ix, iy))
        Next iy, ix
        If MZ <= 0.001 Then MZ = 0.001
        MS = (XR - 5) / MZ
    End Sub   'Maßstab

    Public Sub DimensionierungPlot()
        ReDim xP(nTx, nTy), yP(nTx, nTy)
        ReDim AZ(nTx, nTy)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'nächste Grafik
        Me.Label2.Text = ""
        PLOT = 1
        If IP1 = 0 Then IP1 = 1
        IP1 = IP1 + 1
        If IP1 = 7 Then
            Label3.Text = "Wiederholung"
        Else
            Label3.Text = ""
        End If
        If IP1 = 6 Then IP1 = 1

        'neue Grafik zeichnen
        ix = 0
        Me.Refresh()
        Label7.Text = "(" + Str(ix) + " Durchläufe )"    'Anzahl der Durchläufe
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Zurück zur Startform
        Me.Close()
        frmHalbr.Show()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'neu zeichnen
        'Call Start_Plotten(1, IP)
        ix = 0
        Me.Refresh()
    End Sub

    Public Sub textbox1_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        'Verzerrung x-Richtung
        Call EingPr(TextBox1.Text)
        Verx = Wert1
        Me.Refresh()
    End Sub

    Public Sub textbox2_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        'Verzerrung y-Richtung
        Call EingPr(TextBox2.Text)
        Very = Wert1
        Me.Refresh()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        'Symmetrie
        If Math.Abs(qh) > 0 Then
            CheckBox1.Checked = False
            Exit Sub
        End If
        If CheckBox1.Checked = False Then
            blnSymmetrie = True
        Else
            blnSymmetrie = False
        End If
        If Math.Abs(qz) > 0 Then Call BodenSpgVerf_qz()
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        'Grundlinien zeichnen
        If CheckBox2.Checked = False Then
            blnGrundlinien = False
        Else
            blnGrundlinien = True
        End If
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        'Lastrechteck zeichnen
        If CheckBox3.Checked = False Then
            blnLastfläche = False
        Else
            blnLastfläche = True
        End If
    End Sub

    Public Sub EingPr(ByVal Eing1 As String)
        'Eingabeprüfung
        Dim Stelle As Integer
        Try
            Stelle = InStr(Eing1, ",")
            If Stelle > 0 Then
                Mid(Eing1, Stelle, 1) = "."
            End If
            If Eing1 = "" Then Eing1 = "0"
            Wert1 = Val(Eing1)
            Exit Sub
        Catch
            MsgBox("fehlerhafte Eingabe")
        End Try
    End Sub

End Class